<?php
/**
 * @version		1.0.0
 * @package		Joomla
 * @subpackage	Docman2Edocman
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2011 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );
jimport('joomla.application.component.model');
/**
 * Docman2EDocman Component Migrate Model
 *
 * @package		Joomla
 * @subpackage	Docman2EDocman
 * @since 1.5
 */
class Docman2EdocmanModelMigrate extends JModelLegacy
{					
	function processMigrate() {			
		require_once JPATH_ADMINISTRATOR.'/components/com_edocman/table/category.php' ;
		require_once JPATH_ADMINISTRATOR.'/components/com_edocman/table/document.php' ;
		require_once JPATH_COMPONENT.'/helpers/docman2edocman.php' ;
		$db = JFactory::getDbo() ;
		$config = Docman2EDocmanHelper::getConfig() ;				
		$options = array();
		$options['host'] = $config->host ? $config->host : 'localhost';
		$options['user'] = $config->user ? $config->user : 'root';				
		$options['password'] = $config->password ? $config->password : '';
		$options['database'] = $config->database ? $config->database : '' ;		
		$options['prefix'] = $config->prefix ? $config->prefix : 'jos_';

		$docmanDb = JDatabase::getInstance($options);		
		if ($docmanDb->getErrorNum() > 0) {
			JError::raiseError(500 , 'JDatabase::getInstance: Could not connect to database <br />' . 'joomla.library:'.$db->getErrorNum().' - '.$db->getErrorMsg() );
		}
				
		//Finaly, migrate categories
		$sql = 'SELECT * FROM #__docman_categories WHERE section="com_docman"';
		$docmanDb->setQuery($sql) ;
		$rows = $docmanDb->loadObjectList();				
		$rowCat = JTable::getInstance('Category', 'EdocmanTable') ;
		$mappings = array() ;
		$parents = array() ;
		for ($i = 0 , $n = count($rows) ; $i < $n ; $i++) {
			$row = $rows[$i] ;			
			$name = $db->quote($row->name) ;
			//Check to see whether this categories existed in the system or not
			$sql = 'SELECT id FROM #__edocman_categories WHERE title='.$name;
			$db->setQuery($sql);
			$catId = $db->loadResult() ;
			if (!$catId) {
				$data['id'] = 0 ;
				$data['title'] = $row->name ;
				$data['description'] = $row->description ;
				$data['published'] = $row->published ;
				$rowCat->bind($data);
				$rowCat->store();
				$catId = $rowCat->id ;
			} 						
			$mappings[$row->id] = $catId ;
			if ($row->parent_id) 
			{
				$parents[$row->id] = $row->parent_id ;
			}			
		}
		
		foreach ($parents as $child => $parent) {
			$newChild = $mappings[$child] ;
			$newParent = $mappings[$parent] ;
			$sql = "UPDATE #__edocman_categories SET parent_id=$newParent WHERE id=$newChild";
			$db->setQuery($sql) ;
			$db->query();
		}

		//Now migrate data for Document	
				
		$sql = 'SELECT a.* FROM #__docman AS a ' ;
		$docmanDb->setQuery($sql) ;
		$rows = $docmanDb->loadObjectList();
		$rowDoc =  $this->getTable('Document', 'EDocmanTable');
		for ($i = 0 , $n = count($rows) ; $i < $n ; $i++) {
			$row = $rows[$i] ;
			$data = array();
			$data['id'] = 0 ;
			$data['title'] = $row->dmname ;
			$data['short_description'] = $data['description'] = $row->dmdescription ;			 			
			$data['image'] = $row->dmthumbnail ;
			$data['filename']  = $data['original_filename'] = $row->dmfilename ;								
			$data['published'] = $row->published ;
			$data['created_date'] = $row->dmdate_published ;
			$data['modified_date'] = date('Y-m-d H:i:s') ;
			$data['hits']  = $row->dmcounter ;					
			$rowDoc->bind($data);
			$rowDoc->store();			
			$document_id = $rowDoc->id;
			$category_id = $mappings[$row->catid];
			$is_main_category = 1;
			$db->setQuery("SELECT id FROM #__edocman_document_category WHERE `document_id` = $document_id AND `is_main_category` = $is_main_category");
			$main_category_id = $db->loadResult();
			if ($main_category_id){
			    $db->setQuery("UPDATE #__edocman_document_category SET `category_id`=$category_id WHERE `id` = $main_category_id");
			}else{
			    $db->setQuery("INSERT INTO #__edocman_document_category VALUES (null,$document_id,$category_id,$is_main_category)");
			}
			$db->query();
		}
				
		return true ;
	}	
}